/********************************************************************************************************\

	File Name:	CommonVictory.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/
#include "tclient.h"
#include "ScriptInterface.h"
#include "CommonVictory.h"
#include "CommonVictoryBaseState.h"


tClassAllocator<tCommonVictory> gCommonVictoryAllocator;

/*

	HELPER NOTE:	You must remember to initialize all of your victory attributes here.  For example:

	tCommonVictory::tCommonVictory( ) : fField1( false ), fField2( value ), fField3( value ), etc...
	{}

*/
tCommonVictory::tCommonVictory()
{}
tCommonVictory::tCommonVictory( tTeamInfo* team ) : tVictoryCondition( team )
{}

/*

	HELPER NOTE:	Really, the only item in this function that you could change are the values passed into
					the tCommonVictoryBaseState constructor.  These values are the prestige points awarded according
					to the player's victory status -- starting at kAstoundingVictory and working its way down
					to kDevastatingDefeat.

*/
void tCommonVictory::mSetupState()
{
	tCommonVictoryBaseState* CommonVictoryBaseState = new tCommonVictoryBaseState( 100 , 100 , 0 , 0 , 0 );
	mRegisterState( CommonVictoryBaseState );
	mGotoState( typeid( tCommonVictoryBaseState ) );
}

/*

	HELPER NOTE:	The following is simply an example of setting and modifying the current victory condition
					objectives if the world conditions do not appear useful in this specific script.

	bool
	tCommonVictory::mField1( void )
	{
		return fField1;
	}
	void
	tCommonVictory::mSetField1( bool x )
	{
		fField1 = x;
	}

*/


