/********************************************************************************************************\

	File Name:	DummyState.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "DummyState.h"
#include "Team1.h"
#include "Team2.h"
#include "Team3.h"
#include "Team4.h"
#include "Team5.h"
#include "Team6.h"
#include "TeamA.h"
#include "TeamB.h"
#include "FleetPickData.h"
#include "WorldConditions.h"
#include "MissionText.h"
#include "Mul_FleetPick.h"

static bool FindScriptsDirectory(std::string &location)
{
   HKEY	hKey;
	LONG	lval;
	DWORD	type;
	char	path[256];
	DWORD	siz = 256;

	lval = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
						"Software\\Taldren\\Starfleet Command Orion Pirates",
						0,
						KEY_QUERY_VALUE,
						&hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	lval = RegQueryValueEx(	hKey,
							"Directory",
							0,
							&type,
							(unsigned char *)path,
							&siz );

	RegCloseKey(hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	path[siz] = 0;
	if (path[siz - 1] != '\\')
		strcat(path, "\\");

	strcat(path, "Assets\\Scripts\\");

	location = path;
	return kTrue;

}

void tDummyState::mBeginState()
{
mSetTimedInterval( kTimerTurnsSet, kTitleTimer, 0.50f );
mSetTimedInterval( kTimerTurnsSet, kStartupTextTimer, 0.05f );



}
void tDummyState::mEndState()
{}

void tDummyState::mOnDeath( tShipInfo* ship )
{
	//fMissionInfo->mDebugMessage("tDummyState::mOnDeath");
	  for (int team = (int)kTeam1; team <= (int)kTeam8; team++)
	  {
          tTeamInfo* ti = gScriptInterface.mMission()->mGetTeamHandle((eTeamID)team);

       if(ti->mGetTag() == kTagA && ship->mGetTeam() == (eTeamID)team)
	   {
         gWC.mSetShipDestroyed((eTeamID)team, ship->mGetClassName(), ship->mGetCustomName());
	   }

      if(ti->mGetTag() == kTagB && ship->mGetTeam() == (eTeamID)team)
	  {
        gWC.mSetShipDestroyed((eTeamID)team, ship->mGetClassName(), ship->mGetCustomName());
	  }

	     
	}

}
void tDummyState::mOnCapture( tShipInfo* ship )
{

         for (int team = (int)kTeam1; team <= (int)kTeam8; team++)
		 {
           tTeamInfo* ti = gScriptInterface.mMission()->mGetTeamHandle((eTeamID)team);

            if(ti->mGetTag() == kTagA && ship->mGetTeam() == (eTeamID)team)
			{
                gWC.mSetShipCaptured((eTeamID)team, ship->mGetClassName(), ship->mGetCustomName());
			}
            if(ti->mGetTag() == kTagB && ship->mGetTeam() == (eTeamID)team)
			{ 
                gWC.mSetShipCaptured((eTeamID)team, ship->mGetClassName(), ship->mGetCustomName());
			}
     

		 }
		
}
void tDummyState::mOnDisengaged( tShipInfo* ship )
{

//fMissionInfo->mDebugMessage("tDummyState::mOnDisengaged");
for (int team = (int)kTeam1; team <= (int)kTeam8; team++)
		{
  tTeamInfo* ti = gScriptInterface.mMission()->mGetTeamHandle((eTeamID)team);

  if(ti->mGetTag() == kTagA && ship->mGetTeam() == (eTeamID)team)
  {
    gWC.mSetShipDisengaged((eTeamID)team, ship->mGetClassName(), ship->mGetCustomName());
    ship->mSetTeam(kTeam9);
  }
  if(ti->mGetTag() == kTagB && ship->mGetTeam() == (eTeamID)team)
  {
    gWC.mSetShipDisengaged((eTeamID)team, ship->mGetClassName(), ship->mGetCustomName());
    ship->mSetTeam(kTeam9);
  }
  
        
}

}
 
void tDummyState::mAtDistance( tShipInfo* ship )
{}
void tDummyState::mAtDestination( tShipInfo* ship )
{}
void tDummyState::mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip )
{}
void tDummyState::mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType )
{}
void tDummyState::mOnDeepScan( tShipInfo* ship, iTruth deepScanOn )
{}
void tDummyState::mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus )
{}
void tDummyState::mOnProbeLaunch( tShipInfo* ship )
{}
void tDummyState::mOnBeginOrbit( tShipInfo* ship )
{}
void tDummyState::mOnEndOrbit( tShipInfo* ship )
{}
void tDummyState::mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tDummyState::mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tDummyState::mOnFlashingButtonPressed()
{}
void tDummyState::mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item )
{}
void tDummyState::mOnChangingShip( tShipInfo* ship )
{}
void tDummyState::mOnSpecialTransport( tShipInfo* ship )
{}
void tDummyState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, int32 value )
{}
void tDummyState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, float percent )
{}
void tDummyState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eAccessShipStores_SubTypes subItem, int32 value )
{}
void tDummyState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eScriptTransportItems subItem, int32 value )
{}

void tDummyState::mOnPlayerLeaving( int32 playerNumber, eTeamID TeamID )
{}
void tDummyState::mOnHostChanged()
{

	gWC.mCheckForGameEnd();
}
static char * sCvIntel(int32u i)
{
	switch (i)
	{
		case 0: return "Captain";
		case 1: return "Commodore";
		case 2: return "Admiral";
		default:return "Unknown Value";
	}
}
void tDummyState::mOnTimedInterval( int32 timerID )
{   
	char buf[64];
    std::string	scriptsINI;
	std::string m_str_gameset;

	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";
	
	if ( timerID == kTitleTimer)
	{
	
	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "GameSet",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_str_gameset = buf;
	else
		NULL;
	
	
	        char buff[600];
            sprintf(buff, "FLEET PICK v2.A\n(C)2004 12 Omega Software\nDeveloped by Centauri Vaughn\n\nGame Set: '%s'\nDifficulty Settings: (%s Level)\n", m_str_gameset.c_str(), sCvIntel(gFPD.mGetAIIntel()));
            for (int k = (int)kTeam1; k <= (int)kTeam6; k++)
			fMissionInfo->mDisplayMessage((eTeamID)k, buff);
	}

	if ( timerID == kStartupTextTimer)
	{
		mCreateStartup();
	}


}
void tDummyState::mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType )
{}
void tDummyState::mOnCommStateChange( tActor* actor, int32 state, eStateEvent eventType )
{}

void tDummyState::mCreateStartup()
{

	    
	char buf[64];
    std::string	scriptsINI;
	std::string GameSet;
	std::string position;


	


	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "GameSet",
		            "", buf, 64,
					scriptsINI.c_str());
	

	if (rv)
    GameSet = buf;
	else
	NULL;
	
	if(!gScriptInterface.mIsHost())
		return;
	
	FILE *fp = fopen("C:\\FleetPick Startup.TXT", "w" );

	fprintf(fp, "           Fleet Pick Startup       \n");
	fprintf(fp, "*********************************\n");
    fprintf(fp, "GAME SET: '%s'\n", GameSet.c_str());
		
		


		if( gFPD.mIsShipSelected(kHostSelectShip) )
		{
           fprintf(fp, "SETTINGS: 'Host Selected Ships'\n");
		}
		if( gFPD.mIsShipSelected(kPlyrSelectShip) )
		{
           fprintf(fp, "SETTINGS: 'Player(s) Selected Ships'\n");
		}
				
		if( gFPD.mGetAIIntel() == 0)
		{
          fprintf(fp, "DIFFICULTY LEVEL: ( Captain )\n\n");
		}
		
		if( gFPD.mGetAIIntel() == 1)
		{
          fprintf(fp, "DIFFICULTY LEVEL: ( Commodore )\n\n");
		}
		
		if( gFPD.mGetAIIntel() == 2)
		{
         fprintf(fp, "DIFFICULTY LEVEL: ( Admiral )\n");
		}
		fprintf(fp, "*********************************\n\n");
		fprintf(fp, "SHIPS CREATED:\n");
		fprintf(fp, "=================================\n\n");

	
	    for (int team = (int)kTeam1; team <= (int)kTeam8; team++)
		{
			tTeamInfo * tci = gScriptInterface.mMission()->mGetTeamHandle((eTeamID)team);
			if (tci)    
			{
				//MissingShipList::iterator	msli;

                
				if (tci->mGetTag() == kTagA && team <= kTeam6)
					fprintf(fp, "Player Team %d (A Team Ship) \n", (team - kTeam1) + 1);
				
				if (tci->mGetTag() == kTagB && team <= kTeam6) 
					fprintf(fp, "Player Team %d (B Team Ship)\n", (team - kTeam1) + 1);

				if (tci->mGetTag() == kTagA && team >= kTeam7)
					fprintf(fp, "AI Team %d: (A Team Ship) \n", (team - kTeam1) + 1 );
				
				if (tci->mGetTag() == kTagB && team >= kTeam7) 
					fprintf(fp, "AI Team %d: (B Team Ship)\n", (team - kTeam1) + 1);
                 
                 

				fprintf(fp, "    Ships Created:\n");
				tShipIterator tsi = tci->mGetFirstShip();
				
				 while (*tsi)
				 {
                    if( tsi->mGetStartPositionIndex() <= -1 )
					{
						position = "No Start Position Set";
					}
					if( tsi->mGetStartPositionIndex() == 0 )
					{
						position = "G";
					}
					if( tsi->mGetStartPositionIndex() == 1 )
					{
						position = "H";
					}
					if( tsi->mGetStartPositionIndex() == 2 )
					{
						position = "I";
					}
					if( tsi->mGetStartPositionIndex() == 3 )
					{
						position = "J";
					}
					if( tsi->mGetStartPositionIndex() == 4 )
					{
						position = "K";
					}
					if( tsi->mGetStartPositionIndex() == 5 )
					{
						position = "L";
					}
					if( tsi->mGetStartPositionIndex() == 6 )
					{
						position = "M";
					}
					if( tsi->mGetStartPositionIndex() == 7 )
					{
						position = "N";
					}
					if( tsi->mGetStartPositionIndex() == 8 )
					{
						position = "O";
					}
					if( tsi->mGetStartPositionIndex() == 9 )
					{
						position = "P";
					}
					if( tsi->mGetStartPositionIndex() == 10 )
					{
						position = "Q";
					}
					if( tsi->mGetStartPositionIndex() == 11 )
					{
						position = "R";
					}
					if( tsi->mGetStartPositionIndex() == 12 )
					{
						position = "S";
					}
					if( tsi->mGetStartPositionIndex() == 13 )
					{
						position = "T";
					}
					if( tsi->mGetStartPositionIndex() == 14 )
					{
						position = "U";
					}
					if( tsi->mGetStartPositionIndex() == 15 )
					{
						position = "V";
					}
					if( tsi->mGetStartPositionIndex() == 16 )
					{
						position = "W";
					}
					if( tsi->mGetStartPositionIndex() == 17 )
					{
						position = "X";
					}
					if( tsi->mGetStartPositionIndex() == 18 )
					{
						position = "Y";
					}
					if( tsi->mGetStartPositionIndex() == 19 )
					{
						position = "Z";
					}


					fprintf(fp, "        Ship Name '%s'; Type %s; Start Position Index '%s'\n\n", /*Start Position int32 Value = %d\n\n",*/ tsi->mGetCustomName(), 
					tsi->mGetClassName(),position.c_str(), tsi->mGetStartPositionIndex() );
						
					tsi++;
				 }

			}
		}
        
	   fprintf(fp, "***************************************\n\n");
	
	
	 fclose(fp);
		
}
