

#include "FleetPickData.h"

#include <Windows.h>

#ifdef _DEBUG
#undef THIS_FILE

static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FleetPickData gFPD;

FleetPickData::FleetPickData()
{  
	 m_str_gameset = "";	
	 m_edit_p1 = "";
	 m_edit_p2 = "";
	 m_edit_p3 = "";
	 m_edit_p4 = "";
	 m_edit_p5 = "";
	 m_edit_p6 = "";
	
	 m_edit_a1 = "";
	 m_edit_a2 = "";
	 m_edit_a3 = "";
	 m_edit_a4 = "";
	 m_edit_a5 = "";
	 m_edit_a6 = "",
	 m_edit_a7 = "";
	 m_edit_a8 = "";

	 m_edit_b1 = "";
	 m_edit_b2 = "";
	 m_edit_b3 = "";
	 m_edit_b4 = "";
	 m_edit_b5 = "";
	 m_edit_b6 = "";
	 m_edit_b7 = "";
	 m_edit_b8 = "";

   
	 
}

FleetPickData::~FleetPickData()
{

}
iTruth FleetPickData::FindSFCOPDirectory(std::string &location)
{

	HKEY	hKey;
	LONG	lval;
	DWORD	type;
	char	path[256];
	DWORD	siz = 256;

	lval = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
						"Software\\Taldren\\Starfleet Command Orion Pirates",
						0,
						KEY_QUERY_VALUE,
						&hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	lval = RegQueryValueEx(	hKey,
							"Directory",
							0,
							&type,
							(unsigned char *)path,
							&siz );

	RegCloseKey(hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	path[siz] = 0;
	if (path[siz - 1] != '\\')
		strcat(path, "\\");

	location = path;
	return kTrue;

}

iTruth FleetPickData::FindScriptsDirectory(std::string &location)
{
    iTruth t = FindSFCOPDirectory(location);
	if (t == kTrue)
		location.append("Assets\\Scripts\\");

	return t;
}

iTruth	FleetPickData::Load(void)
{

	char buf[64];
    std::string	scriptsINI;
	if (!FindScriptsDirectory(scriptsINI))
		return kFalse;
    scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "GameSet",
		            "", buf, 64,
					scriptsINI.c_str());
	

	if (rv)
    m_str_gameset = buf;
	
	
	
	rv = GetPrivateProfileString("Mul_FleetPick", "shipP1",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
    m_edit_p1 = buf;
		

	else
		NULL;
	
	rv = GetPrivateProfileString("Mul_FleetPick", "shipP2",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	
		m_edit_p2 = buf;
	
	else
	
		NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "shipP3",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_p3 = buf;
	else
		NULL; 

		rv = GetPrivateProfileString("Mul_FleetPick", "shipP4",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_p4 = buf;
	else
		NULL; 

	   	rv = GetPrivateProfileString("Mul_FleetPick", "shipP5",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_p5 = buf;
	else
		NULL; 

		rv = GetPrivateProfileString("Mul_FleetPick", "shipP6",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_p6 = buf;
	else
		NULL; 

		rv = GetPrivateProfileString("Mul_FleetPick", "shipA1",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a1 = buf;
	else
		NULL; 

	   	rv = GetPrivateProfileString("Mul_FleetPick", "shipA2",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a2 = buf;
	else
		NULL; 
	
		rv = GetPrivateProfileString("Mul_FleetPick", "shipA3",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a3 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipA4",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a4 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipA5",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a5 = buf;
	else
		NULL; 

		rv = GetPrivateProfileString("Mul_FleetPick", "shipA6",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a6 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipA7",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a7 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipA8",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_a8 = buf;
	else
		NULL; 

	
		rv = GetPrivateProfileString("Mul_FleetPick", "shipB1",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b1 = buf;
	else
		NULL; 

	   	rv = GetPrivateProfileString("Mul_FleetPick", "shipB2",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b2 = buf;
	else
		NULL; 
	
		rv = GetPrivateProfileString("Mul_FleetPick", "shipB3",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b3 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipB4",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b4 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipB5",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b5 = buf;
	else
		NULL; 

		rv = GetPrivateProfileString("Mul_FleetPick", "shipB6",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b6 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipB7",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b7 = buf;
	else
		NULL; 

	rv = GetPrivateProfileString("Mul_FleetPick", "shipB8",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		m_edit_b8 = buf;
	else
		NULL; 

	
	rv = GetPrivateProfileString("Mul_FleetPick", "p1Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_p1_pos = atof(buf);
	else
		gFPD.m_p1_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "p2Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_p2_pos = atof(buf);
	else
		gFPD.m_p2_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "p3Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_p3_pos = atof(buf);
	else
		gFPD.m_p3_pos = -1;

    rv = GetPrivateProfileString("Mul_FleetPick", "p4Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_p4_pos = atof(buf);
	else
		gFPD.m_p4_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "p5Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_p5_pos = atof(buf);
	else
		gFPD.m_p5_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "p6Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_p6_pos = atof(buf);
	else
		gFPD.m_p6_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a1Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a1_pos = atof(buf);
	else
		gFPD.m_a1_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a2Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a2_pos = atof(buf);
	else
		gFPD.m_a2_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a3Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a3_pos = atof(buf);
	else
		gFPD.m_a3_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a4Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a4_pos = atof(buf);
	else
		gFPD.m_a4_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a5Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a5_pos = atof(buf);
	else
		gFPD.m_a5_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a6Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a6_pos = atof(buf);
	else
		gFPD.m_a6_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a7Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a7_pos = atof(buf);
	else
		gFPD.m_a7_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "a8Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a8_pos = atof(buf);
	else
		gFPD.m_a8_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b1Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b1_pos = atof(buf);
	else
		gFPD.m_b1_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b2Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b2_pos = atof(buf);
	else
		gFPD.m_b2_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b3Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b3_pos = atof(buf);
	else
		gFPD.m_b3_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b4Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b4_pos = atof(buf);
	else
		gFPD.m_b4_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b5Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b5_pos = atof(buf);
	else
		gFPD.m_b5_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b6Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b6_pos = atof(buf);
	else
		gFPD.m_b6_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b7Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b7_pos = atof(buf);
	else
		gFPD.m_b7_pos = -1;

	rv = GetPrivateProfileString("Mul_FleetPick", "b8Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b8_pos = atof(buf);
	else
		gFPD.m_b8_pos = -1;

    		 
	 rv = GetPrivateProfileString("Mul_FleetPick", "shipSettings",
	           "", buf, 64,
				scriptsINI.c_str());
	if (rv)
		fShipSettings = atoi(buf);
	else
		NULL;


	
	std::string	sfcINI;
	if (!FindSFCOPDirectory(sfcINI))
		return kFalse;
	
	sfcINI += "sfc.ini";

	rv = GetPrivateProfileString("UI", "UIType","", buf, 64, sfcINI.c_str());

	if (rv)
		fAIIntel = atof(buf);
	else
		fAIIntel = 0;				
	 	

	return kTrue;
	
}

iTruth FleetPickData::Save(void)
{ 
	char buf[64];

    std::string	scriptsINI;
	if (!FindScriptsDirectory(scriptsINI))
	return kFalse;
	scriptsINI += "scripts.ini";


    std::string	sfcINI;
	if (!FindSFCOPDirectory(sfcINI))
	return kFalse;
	sfcINI += "sfc.ini";

	sprintf(buf, "%s", m_str_gameset);
	if (!WritePrivateProfileString("Mul_FleetPick", "GameSet",
								   buf, scriptsINI.c_str()))
		return kFalse;


    sprintf(buf, "%s", m_edit_p1);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipP1",
								   buf, scriptsINI.c_str()))
		return kFalse;
    

	 sprintf(buf, "%s", m_edit_p2);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipP2",
								    buf, scriptsINI.c_str()))
		return kFalse;
    
	
	
	 sprintf(buf, "%s", m_edit_p3);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipP3",
								    buf, scriptsINI.c_str()))
		return kFalse;
    
    sprintf(buf, "%s", m_edit_p4);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipP4",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_p5);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipP5",
								    buf, scriptsINI.c_str()))
		return kFalse;

     sprintf(buf, "%s", m_edit_p6);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipP6",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_a1);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA1",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_a2);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA2",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_a3);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA3",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_a4);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA4",
								    buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%s", m_edit_a5);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA5",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%s", m_edit_a6);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA6",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%s", m_edit_a7);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA7",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%s", m_edit_a8);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipA8",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_b1);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB1",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_b2);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB2",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_b3);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB3",
								    buf, scriptsINI.c_str()))
		return kFalse;

	 sprintf(buf, "%s", m_edit_b4);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB4",
								    buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%s", m_edit_b5);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB5",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%s", m_edit_b6);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB6",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%s", m_edit_b7);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB7",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%s", m_edit_b8);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipB8",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_p1_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "p1Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%d", m_p2_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "p2Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%d", m_p3_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "p3Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_p4_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "p4Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_p5_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "p5Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_p6_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "p6Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a1_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a1Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a2_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a2Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a3_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a3Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a4_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a4Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a5_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a5Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a6_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a6Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a7_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a7Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_a8_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "a8Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b1_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b1Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b2_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b2Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b3_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b3Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b4_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b4Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b5_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b5Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b6_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b6Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b7_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b7Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	sprintf(buf, "%d", m_b8_pos);
	if (!WritePrivateProfileString("Mul_FleetPick", "b8Pos",
								    buf, scriptsINI.c_str()))
		return kFalse;

	
	sprintf(buf, "%d", fShipSettings);
	if (!WritePrivateProfileString("Mul_FleetPick", "shipSettings",
								     buf, scriptsINI.c_str()))
	return kFalse;

	sprintf(buf, "%d", fAIIntel);
	if (!WritePrivateProfileString("UI", "UIType",
								   buf, sfcINI.c_str()))
		return kFalse;

return kTrue;

}



int32u FleetPickData::mGetShipSettings(void) { return fShipSettings; }
void FleetPickData::mSetShipSettings(int32u m) { fShipSettings |= (1 << m); }
void FleetPickData::mResetShipSettings(void) { fShipSettings = 0;} 
iTruth  FleetPickData::mIsShipSelected(int32u m) { return (fShipSettings & (1 << m)) != 0; }

int32u	FleetPickData::mGetAIIntel(void) { return fAIIntel; }
void    FleetPickData::mSetAIIntel(int32u i) { fAIIntel = i; }
