// FleetPickData.h: interface for the FleetPickData class.
//
//////////////////////////////////////////////////////////////////////

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "tclient.h"
#include "scriptsdata.h"
#include "soundnums.h"


enum 
{
	kPlyrSelectShip = 1,
	kHostSelectShip = 2,
};

class FleetPickData  
{
public:
	FleetPickData();
	virtual ~FleetPickData();
	
   void SetGameTitle(const char* Title) { m_str_gameset = Title; } 
   
   void SetShipP1(const char* ShipP1) { m_edit_p1 = ShipP1; } 
   void SetShipP2(const char* ShipP2) { m_edit_p2 = ShipP2; } 
   void SetShipP3(const char* ShipP3) { m_edit_p3 = ShipP3; } 
   void SetShipP4(const char* ShipP4) { m_edit_p4 = ShipP4; } 
   void SetShipP5(const char* ShipP5) { m_edit_p5 = ShipP5; } 
   void SetShipP6(const char* ShipP6) { m_edit_p6 = ShipP6; } 


   void SetShipA1(const char* ShipA1) { m_edit_a1 = ShipA1; } 
   void SetShipA2(const char* ShipA2) { m_edit_a2 = ShipA2; } 
   void SetShipA3(const char* ShipA3) { m_edit_a3 = ShipA3; } 
   void SetShipA4(const char* ShipA4) { m_edit_a4 = ShipA4; } 
   void SetShipA5(const char* ShipA5) { m_edit_a5 = ShipA5; } 
   void SetShipA6(const char* ShipA6) { m_edit_a6 = ShipA6; } 
   void SetShipA7(const char* ShipA7) { m_edit_a7 = ShipA7; } 
   void SetShipA8(const char* ShipA8) { m_edit_a8 = ShipA8; } 

   void SetShipB1(const char* ShipB1) { m_edit_b1 = ShipB1; } 
   void SetShipB2(const char* ShipB2) { m_edit_b2 = ShipB2; } 
   void SetShipB3(const char* ShipB3) { m_edit_b3 = ShipB3; } 
   void SetShipB4(const char* ShipB4) { m_edit_b4 = ShipB4; } 
   void SetShipB5(const char* ShipB5) { m_edit_b5 = ShipB5; } 
   void SetShipB6(const char* ShipB6) { m_edit_b6 = ShipB6; } 
   void SetShipB7(const char* ShipB7) { m_edit_b7 = ShipB7; } 
   void SetShipB8(const char* ShipB8) { m_edit_b8 = ShipB8; } 
   

   const char* GetGameTitle() { return m_str_gameset; }
   
   const char* GetShipP1() { return m_edit_p1; }
   const char* GetShipP2() { return m_edit_p2; }
   const char* GetShipP3() { return m_edit_p3; }
   const char* GetShipP4() { return m_edit_p4; }
   const char* GetShipP5() { return m_edit_p5; }
   const char* GetShipP6() { return m_edit_p6; }

   const char* GetShipA1() { return m_edit_a1; }
   const char* GetShipA2() { return m_edit_a2; }
   const char* GetShipA3() { return m_edit_a3; }
   const char* GetShipA4() { return m_edit_a4; }
   const char* GetShipA5() { return m_edit_a5; }
   const char* GetShipA6() { return m_edit_a6; }
   const char* GetShipA7() { return m_edit_a7; }
   const char* GetShipA8() { return m_edit_a8; }

   const char* GetShipB1() { return m_edit_b1; }
   const char* GetShipB2() { return m_edit_b2; }
   const char* GetShipB3() { return m_edit_b3; }
   const char* GetShipB4() { return m_edit_b4; }
   const char* GetShipB5() { return m_edit_b5; }
   const char* GetShipB6() { return m_edit_b6; }
   const char* GetShipB7() { return m_edit_b7; }
   const char* GetShipB8() { return m_edit_b8; }

     

   void SetP1ShipPosition(int32 Pos) { m_p1_pos = Pos; } 
   int32 GetP1ShipPosition() { return m_p1_pos; }
   
   void SetP2ShipPosition(int32 Pos) { m_p2_pos = Pos; } 
   int32 GetP2ShipPosition() { return m_p2_pos; }
   
   void SetP3ShipPosition(int32 Pos) { m_p3_pos = Pos; } 
   int32 GetP3ShipPosition() { return m_p3_pos; }
   
   void SetP4ShipPosition(int32 Pos) { m_p4_pos = Pos; } 
   int32 GetP4ShipPosition() { return m_p4_pos; }
   
   void SetP5ShipPosition(int32 Pos) { m_p5_pos = Pos; } 
   int32 GetP5ShipPosition() { return m_p5_pos; }
   
   void SetP6ShipPosition(int32 Pos) { m_p6_pos = Pos; } 
   int32 GetP6ShipPosition() { return m_p6_pos; }

   
   
   void SetA1ShipPosition(int32 Pos) { m_a1_pos = Pos; } 
   int32 GetA1ShipPosition() { return m_a1_pos; }
   
   void SetA2ShipPosition(int32 Pos) { m_a2_pos = Pos; } 
   int32 GetA2ShipPosition() { return m_a2_pos; }
   
   void SetA3ShipPosition(int32 Pos) { m_a3_pos = Pos; } 
   int32 GetA3ShipPosition() { return m_a3_pos; }
   
   void SetA4ShipPosition(int32 Pos) { m_a4_pos = Pos; } 
   int32 GetA4ShipPosition() { return m_a4_pos; }
   
   void SetA5ShipPosition(int32 Pos) { m_a5_pos = Pos; } 
   int32 GetA5ShipPosition() { return m_a5_pos; }
   
   void SetA6ShipPosition(int32 Pos) { m_a6_pos = Pos; } 
   int32 GetA6ShipPosition() { return m_a6_pos; }

   void SetA7ShipPosition(int32 Pos) { m_a7_pos = Pos; } 
   int32 GetA7ShipPosition() { return m_a7_pos; }
   
   void SetA8ShipPosition(int32 Pos) { m_a8_pos = Pos; } 
   int32 GetA8ShipPosition() { return m_a8_pos; }



   void SetB1ShipPosition(int32 Pos) { m_b1_pos = Pos; } 
   int32 GetB1ShipPosition() { return m_b1_pos; }
   
   void SetB2ShipPosition(int32 Pos) { m_b2_pos = Pos; } 
   int32 GetB2ShipPosition() { return m_b2_pos; }
   
   void SetB3ShipPosition(int32 Pos) { m_b3_pos = Pos; } 
   int32 GetB3ShipPosition() { return m_b3_pos; }
   
   void SetB4ShipPosition(int32 Pos) { m_b4_pos = Pos; } 
   int32 GetB4ShipPosition() { return m_b4_pos; }
   
   void SetB5ShipPosition(int32 Pos) { m_b5_pos = Pos; } 
   int32 GetB5ShipPosition() { return m_b5_pos; }
   
   void SetB6ShipPosition(int32 Pos) { m_b6_pos = Pos; } 
   int32 GetB6ShipPosition() { return m_b6_pos; }

   void SetB7ShipPosition(int32 Pos) { m_b7_pos = Pos; } 
   int32 GetB7ShipPosition() { return m_b7_pos; }
   
   void SetB8ShipPosition(int32 Pos) { m_b8_pos = Pos; } 
   int32 GetB8ShipPosition() { return m_b8_pos; }


	
	
	
	iTruth	FindScriptsDirectory(std::string &location);
	iTruth	FindSFCOPDirectory(std::string &location);
	iTruth	Load(void);
	iTruth	Save(void);

	
	int32u mGetShipSettings(void);
	void   mSetShipSettings(int32u);
	void   mResetShipSettings(void);
	iTruth mIsShipSelected(int32u);

	int32u	mGetAIIntel(void);
	void	mSetAIIntel(int32u);
	
		
	const char*  m_str_gameset;		
	const char*  m_edit_p1;
	const char*  m_edit_p2;
	const char*  m_edit_p3;
	const char*  m_edit_p4;
	const char*  m_edit_p5;
	const char*  m_edit_p6;
	
	const char*  m_edit_a1;
	const char*  m_edit_a2;
	const char*  m_edit_a3;
	const char*  m_edit_a4;
	const char*  m_edit_a5;
	const char*  m_edit_a6;
	const char*  m_edit_a7;
	const char*  m_edit_a8;

	const char*  m_edit_b1;
	const char*  m_edit_b2;
	const char*  m_edit_b3;
	const char*  m_edit_b4;
	const char*  m_edit_b5;
	const char*  m_edit_b6;
	const char*  m_edit_b7;
	const char*  m_edit_b8;

     int32 m_p1_pos;
	 int32 m_p2_pos;
	 int32 m_p3_pos;
	 int32 m_p4_pos;
	 int32 m_p5_pos;
	 int32 m_p6_pos;

	 int32 m_a1_pos;
	 int32 m_a2_pos;
	 int32 m_a3_pos;
	 int32 m_a4_pos;
	 int32 m_a5_pos;
	 int32 m_a6_pos;
	 int32 m_a7_pos;
	 int32 m_a8_pos;

	 int32 m_b1_pos;
	 int32 m_b2_pos;
	 int32 m_b3_pos;
	 int32 m_b4_pos;
	 int32 m_b5_pos;
	 int32 m_b6_pos;
	 int32 m_b7_pos;
	 int32 m_b8_pos;
     
	

private:

    

    int32u fShipSettings;
	int32u  fAIIntel;// Stored in sfc.ini [UI] UIType (Admiral=2 Captain=0)

};

extern FleetPickData gFPD;