/********************************************************************************************************\

	File Name:	TeamA.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "tclient.h"
#include "CommonDefs.h"
#include "TeamA.h"
#include "scriptinterface.h"
#include "FleetPickData.h"
#include "ShipList.h"
#include "DummyState.h"
#include "Mul_FleetPick.h"



tClassAllocator<tTeamA> gTeamAAllocator;

static bool FindScriptsDirectory(std::string &location)
{
   HKEY	hKey;
	LONG	lval;
	DWORD	type;
	char	path[256];
	DWORD	siz = 256;

	lval = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
						"Software\\Taldren\\Starfleet Command Orion Pirates",
						0,
						KEY_QUERY_VALUE,
						&hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	lval = RegQueryValueEx(	hKey,
							"Directory",
							0,
							&type,
							(unsigned char *)path,
							&siz );

	RegCloseKey(hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	path[siz] = 0;
	if (path[siz - 1] != '\\')
		strcat(path, "\\");

	strcat(path, "Assets\\Scripts\\");

	location = path;
	return kTrue;
}

/*

	HELPER NOTE:	If you create any new states on the team level, you must register them here first.

*/
void tTeamA::mSetupState()
{
	//mRegisterState( new tTeamABaseState() );
	//mGotoState( typeid( tTeamABaseState ) );
}

void tTeamA::mSetupCommState()
{}

void tTeamA::mCreateShipsForTeam()
{
	if (!gScriptInterface.mIsHost())
		return;	

	gFPD.Load();
	
		if ( gFPD.GetShipA1() != "" )
		{
			CreateAShip1();
		}
		if ( gFPD.GetShipA2() != "" )
		{
			CreateAShip2();
		}
			if ( gFPD.GetShipA3() != "" )
		{
			CreateAShip3();
		}
		if ( gFPD.GetShipA4() != "" )
		{
			CreateAShip4();
		}
			if ( gFPD.GetShipA5() != "" )
		{
			CreateAShip5();
		}
		if ( gFPD.GetShipA6() != "" )
		{
			CreateAShip6();
		}
			if ( gFPD.GetShipA7() != "" )
		{
			CreateAShip7();
		}
		if ( gFPD.GetShipA8() != "" )
		{
			CreateAShip8();
		}
}


void tTeamA::CreateAShip1()
{
	char buf[64];
	
	std::string gShipA1;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA1",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA1 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "a1Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a1_pos = atof(buf);
	else
		gFPD.m_a1_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA1,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a1_pos,
		    	kNoMetaShipID,
				kAShip1, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip2()
{
    
	char buf[64];
	
	std::string gShipA2;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA2",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA2 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "a2Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a2_pos = atof(buf);
	else
		gFPD.m_a2_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA2,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a2_pos,
		    	kNoMetaShipID,
				kAShip2, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip3()
{
	char buf[64];
	
	std::string gShipA3;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA3",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA3 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "a3Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a3_pos = atof(buf);
	else
		gFPD.m_a3_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA3,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a3_pos,
		    	kNoMetaShipID,
				kAShip3, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip4()
{
	char buf[64];
	
	std::string gShipA4;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA4",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA4 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "a4Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a4_pos = atof(buf);
	else
		gFPD.m_a4_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA4,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a4_pos,
		    	kNoMetaShipID,
				kAShip4, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip5()
{
	char buf[64];
	
	std::string gShipA5;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA5",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA5 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "a5Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a5_pos = atof(buf);
	else
		gFPD.m_a5_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA5,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a5_pos,
		    	kNoMetaShipID,
				kAShip5, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip6()
{
	char buf[64];
	
	std::string gShipA6;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA6",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA6 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "a6Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a6_pos = atof(buf);
	else
		gFPD.m_a6_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA6,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a6_pos,
		    	kNoMetaShipID,
				kAShip6, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip7()
{
	char buf[64];
	
	std::string gShipA7;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA7",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA7 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "a7Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a7_pos = atof(buf);
	else
		gFPD.m_a7_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA7,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a7_pos,
		    	kNoMetaShipID,
				kAShip7, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::CreateAShip8()
{
	char buf[64];
	
	std::string gShipA8;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipA8",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipA8 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "a8Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_a8_pos = atof(buf);
	else
		gFPD.m_a8_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipA8,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_a8_pos,
		    	kNoMetaShipID,
				kAShip8, 0, 0, -1, -1, "AI Team A", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamA::mTeamSetupComplete()
{
	tTeamInfo::mTeamSetupComplete();
}


