/********************************************************************************************************\

	File Name:	TeamB.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "tclient.h"
#include "CommonDefs.h"
#include "TeamB.h"
#include "scriptinterface.h"
#include "DummyState.h"
#include "FleetPickData.h"
#include "ShipList.h"
#include "Mul_FleetPick.h"


tClassAllocator<tTeamB> gTeamAAllocator;

static bool FindScriptsDirectory(std::string &location)
{
   HKEY	hKey;
	LONG	lval;
	DWORD	type;
	char	path[256];
	DWORD	siz = 256;

	lval = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
						"Software\\Taldren\\Starfleet Command Orion Pirates",
						0,
						KEY_QUERY_VALUE,
						&hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	lval = RegQueryValueEx(	hKey,
							"Directory",
							0,
							&type,
							(unsigned char *)path,
							&siz );

	RegCloseKey(hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	path[siz] = 0;
	if (path[siz - 1] != '\\')
		strcat(path, "\\");

	strcat(path, "Assets\\Scripts\\");

	location = path;
	return kTrue;
}
/*

	HELPER NOTE:	If you create any new states on the team level, you must register them here first.

*/
void tTeamB::mSetupState()
{
//	mRegisterState( new tTeamBBaseState() );
//	mGotoState( typeid( tTeamBBaseState ) );
}

void tTeamB::mSetupCommState()
{}


void tTeamB::mCreateShipsForTeam()
{
	if (!gScriptInterface.mIsHost())
		return;	

	gFPD.Load();
	
		if ( gFPD.GetShipB1() != "" )
		{
			CreateBShip1();
		}
		if ( gFPD.GetShipB2() != "" )
		{
			CreateBShip2();
		}
			if ( gFPD.GetShipB3() != "" )
		{
			CreateBShip3();
		}
		if ( gFPD.GetShipB4() != "" )
		{
			CreateBShip4();
		}
			if ( gFPD.GetShipB5() != "" )
		{
			CreateBShip5();
		}
		if ( gFPD.GetShipB6() != "" )
		{
			CreateBShip6();
		}
			if ( gFPD.GetShipB7() != "" )
		{
			CreateBShip7();
		}
		if ( gFPD.GetShipB8() != "" )
		{
			CreateBShip8();
		}
}


void tTeamB::CreateBShip1()
{

//	gFPD.Load();
	char buf[64];
	std::string gShipB1;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB1",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB1 = buf;
	else
    NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "b1Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b1_pos = atof(buf);
	else
		gFPD.m_b1_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);
                
                
    	        sl.Find(gShipB1,(s));
	            mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b1_pos,
		    	kNoMetaShipID,
				kBShip1, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);




//mCreateShip( typeid( tShipInfo ), m_edit_b1, gFPD.m_b1_pos, kNoMetaShipID,
//kBShip1, 0, 0, -1, -1, "Dominion BB", kDeathUponCapture);

}

void tTeamB::CreateBShip2()
{
    
	char buf[64];
	
	std::string gShipB2;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB2",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB2 = buf;
	else
	NULL;

	rv = GetPrivateProfileString("Mul_FleetPick", "b2Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b2_pos = atof(buf);
	else
		gFPD.m_b2_pos = -1;

	ShipList sl;

    Ship s;

	

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB2,(s));
	            mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b2_pos,
		    	kNoMetaShipID,
				kBShip2, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::CreateBShip3()
{
	char buf[64];
	
	std::string gShipB3;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB3",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB3 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "b3Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b3_pos = atof(buf);
	else
		gFPD.m_b3_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB3,(s));
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b3_pos,
		    	kNoMetaShipID,
				kBShip3, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::CreateBShip4()
{
	char buf[64];
	
	std::string gShipB4;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB4",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB4 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "b4Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b4_pos = atof(buf);
	else
		gFPD.m_b4_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB4,(s));
	            mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b4_pos,
		    	kNoMetaShipID,
				kBShip4, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::CreateBShip5()
{
	char buf[64];
	
	std::string gShipB5;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB5",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB5 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "b5Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b5_pos = atof(buf);
	else
		gFPD.m_b5_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB5,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b5_pos,
		    	kNoMetaShipID,
				kBShip5, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::CreateBShip6()
{
	char buf[64];
	
	std::string gShipB6;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB6",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB6 = buf;
    else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "b6Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b6_pos = atof(buf);
	else
		gFPD.m_b6_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB6,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b6_pos,
		    	kNoMetaShipID,
				kBShip6, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::CreateBShip7()
{
	char buf[64];
	
	std::string gShipB7;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB7",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB7 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "b7Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b7_pos = atof(buf);
	else
		gFPD.m_b7_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB7,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b7_pos,
		    	kNoMetaShipID,
				kBShip7, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::CreateBShip8()
{
	char buf[64];
	
	std::string gShipB8;
	std::string	scriptsINI;
	FindScriptsDirectory(scriptsINI);
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString("Mul_FleetPick", "shipB8",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
	gShipB8 = buf;
	else
	NULL;
	

	rv = GetPrivateProfileString("Mul_FleetPick", "b8Pos",
		            "", buf, 64,
					scriptsINI.c_str());
	if (rv)
		gFPD.m_b8_pos = atof(buf);
	else
		gFPD.m_b8_pos = -1;

	ShipList sl;

    Ship s;

	sl.CreateMaster(ShipList::kOrionPirates, false);

     
    	        sl.Find(gShipB8,(s));
		
		        mCreateShip( typeid( tShipInfo),		             
                s.shipCode.c_str(),
				gFPD.m_b8_pos,
		    	kNoMetaShipID,
				kBShip8, 0, 0, -1, -1, "AI Team B", 
		 	    kCanAddToFleetUponCapture);
}

void tTeamB::mTeamSetupComplete()
{
	tTeamInfo::mTeamSetupComplete();
}